//****************************************************************************
//
// EvalBot : exmple d'utilisation de
// Oled
// UART0 ou UART1
// Sonar Ultra-son SRF05 avec GPIO (Irq) + TImer
//
//****************************************************************************

#include "inc/hw_types.h"
#include "inc/hw_memmap.h"
#include "driverlib/sysctl.h"
#include "driverlib/flash.h"
#include "driverlib/debug.h"
#include "driverlib/interrupt.h"
#include "driverlib/udma.h"
#include "drivers/display96x16x1.h"
#include "drivers/motor.h"
#include "drivers/io.h"
#include "drivers/sensors.h"
#include "drivers/dac.h"
#include "drivers/sound.h"
#include "drivers/wav.h"
#include "utils/uartstdio.h"
#include "utils/ustdlib.h"
#include "utils/scheduler.h"
#include "simplicitilib.h"
#include "sounds.h"
#include <string.h>
#include "driverlib/uart.h"
#include "driverlib/timer.h"

//*****************************************************************************
//
// For debug purposes, define this label to keep the motors disabled at all
// times.
//
//*****************************************************************************
//#define KEEP_MOTORS_DISABLED

//*****************************************************************************
//
// Defines
//
//*****************************************************************************
#define CLEAR 1
#define HideCurs    "\033[?25l"
#define ClearScreen "\033[H\033[2J"

static unsigned int p;
static unsigned char rising;

void UARTelipse()
{
  	static unsigned char j = 0;
	static char elipse[] = "|/-\\|/-\\";

	UARTprintf("\33[4;5H");
	UARTwrite(&elipse[j],1);
	j++; if (j >= 8) j = 0;
}

//*****************************************************************************
//
// Main application entry point.
//
//*****************************************************************************
/*void PortCIntHandler()
{
	GPIOPinIntClear( GPIO_PORTC_BASE, (GPIO_PIN_5) );
	if (rising == 0) {
		TimerLoadSet(TIMER0_BASE, TIMER_A, 0xffffff);
		TimerEnable(TIMER0_BASE, TIMER_A);
		rising = 1;
	} else {		
		p = TimerValueGet(TIMER0_BASE, TIMER_A);
		TimerDisable(TIMER0_BASE, TIMER_A);
		rising = 0;
	}
}
*/
int main (void)
{
	unsigned long int i;
	 unsigned int d;

    //
    // Set the system clock to run at 50MHz from the PLL
    //
    SysCtlClockSet(SYSCTL_SYSDIV_4 | SYSCTL_USE_PLL | SYSCTL_OSC_MAIN |
                   SYSCTL_XTAL_16MHZ);
    //
    // Enable UART0.
    //
    SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOA);
    SysCtlPeripheralEnable(SYSCTL_PERIPH_UART0);

    GPIOPinTypeUART(GPIO_PORTA_BASE, GPIO_PIN_0 | GPIO_PIN_1);

    //
    // Initialize the UART 0 port serie sur USB
    //  

	UARTConfigSetExpClk(UART0_BASE, SysCtlClockGet(), 115200,
                        (UART_CONFIG_WLEN_8 | UART_CONFIG_STOP_ONE |
                         UART_CONFIG_PAR_NONE));

    //
    // Initialize and Enable UART1 port serie sur pins
    //
    SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOB);
    SysCtlPeripheralEnable(SYSCTL_PERIPH_UART1);

	GPIOPinConfigure(GPIO_PB4_U1RX);
    GPIOPinConfigure(GPIO_PB5_U1TX);

    GPIOPinTypeUART(GPIO_PORTB_BASE, GPIO_PIN_4 | GPIO_PIN_5);

	UARTConfigSetExpClk(UART1_BASE, SysCtlClockGet(), 115200,
                        (UART_CONFIG_WLEN_8 | UART_CONFIG_STOP_ONE |
                         UART_CONFIG_PAR_NONE));
 
    //
    // Initialize the UART standard I/O.
    //
    UARTStdioInit(1); // pour rediriger es STDIO sur le UART O (port serie usb)
 
    //
    // Print a nice welcoming banner on the serial output.
    //

	UARTprintf(ClearScreen);  // efface la console 
    UARTprintf("EVALBOT GPIO TEST PORT J\n");
    UARTprintf("------------------------\n");
	UARTprintf(HideCurs);	  // efface le curseur
    //
    // Initialize the LED display.
    //
    Display96x16x1Init(true);
    Display96x16x1Clear();
	Display96x16x1StringDrawCentered("Test GPIO PORT J", 0, CLEAR);
//	Display96x16x1StringDrawCentered("TEST GPIO", 1, CLEAR);
    //
    // Initialize the board LEDs.
    //
    LEDsInit();

	//
	// Initialize the GPIO pin configuration.
	//
	// Set pins 1 as output, SW controlled.
	//
	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOJ); 

	GPIOPinTypeGPIOOutput( GPIO_PORTJ_BASE, (GPIO_PIN_1) ); // PJ1 en sortie

	// PJ1 en sortie standard + 2 mA 
	GPIOPadConfigSet( GPIO_PORTJ_BASE, (GPIO_PIN_1), GPIO_STRENGTH_2MA, GPIO_PIN_TYPE_STD );

 	//GPIOPortIntRegister(GPIO_PORTC_BASE, PortCIntHandler);
	//GPIOPinIntEnable(GPIO_PORTC_BASE, GPIO_PIN_5 );
	//GPIOIntTypeSet(GPIO_PORTC_BASE, GPIO_PIN_5, GPIO_BOTH_EDGES);
    //GPIOPinIntEnable(GPIO_PORTC_BASE, GPIO_PIN_5);
	//IntMasterEnable();

	for (;;) {
//	    UARTelipse();
//		GPIOPinWrite( GPIO_PORTC_BASE,(GPIO_PIN_4), 0x00);
		// Pulse 15us vers SRF05
		GPIOPinWrite( GPIO_PORTJ_BASE,(GPIO_PIN_1), 0xff);
		for (i=0;i<10000;i++);
//	    UARTelipse();
		GPIOPinWrite( GPIO_PORTJ_BASE,(GPIO_PIN_1), 0x00);
		for (i=0;i<30000;i++);
		
//		Display96x16x1ClearLine(1);
//		Display96x16x1StringDrawCenteredPrintf(1,1,"%u", 65535-p );
	}				
}