      include  generale.s
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; les GPIOS pour l'ecran LCD
; LCD connect sur le Port H + Port C comme suit: 
;
;    PH7..PH4 => DB7..DB4
;    PH3      => E
;    PH2      => R/W
;    PC4      => RS
;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; les GPIOS pour l'ecran LCD
; LCD connect sur le Port H + Port C comme suit: 
;    PH7..PH4 => DB7..DB4
;    PH3      => E
;    PH2      => R/W
;    PC4      => RS
;
DB7   equ   PORT7
DB6   equ   PORT6
DB5   equ   PORT5
DB4   equ   PORT4
E     equ   PORT3
RW    equ   PORT2
RS    equ   PORT4

         AREA    |.text|, CODE, READONLY
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  Procedure d'attente en fonction de r1
      export   wait
wait  push  {r1,lr}
wait_loop
      subs  r1, #1
      bne   wait_loop
      pop   {r1,pc}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Init des GPIO du LCD
;
      export gpio_init_LCD
gpio_init_LCD
      push {r0,r3,r6,lr}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Init des registres GPIOs
;
; activation des horloges des ports C et H
;
      ldr r6, = SYSCTL_RCGC2 ; voir p412 Init et config des GPIOs
      ldr r0, [r6]
      orr r0,r0, #0x0084 ; Enable clock sur GPIOH + GPIOC p292
      str r0, [r6]         ;
		nop	               ; tres tres important....merci Thierry (beaucoup temps perdu, cf petite note p414!)
		nop                  ; "There must be  a delay of 3 system clocks before any GPIO reg. access
		nop	               ; pas necessaire en simu  ou en debbug step by step...@#@! :-(

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Port C (signal RS du LCD) direction
      ldr r6, = GPIO_PORTC_BASE + GPIODIR ;  Pins du port C en sortie
      ldr r0, [r6]
      orr r0,r0, #PORT4    ; singal RS en sortie
      str r0, [r6]
; Port C (RS) intensit	
;		ldr r6, = GPIO_PORTC_BASE + GPIODR2R	; Choix de l'intensit de sortie (2mA)
;     ldr r0, = PORT4 
;     str r0, [r6]
; Port C (RS) Enable
      ldr r6, = GPIO_PORTC_BASE + GPIODEN ;  Pins du port C  enable
      ldr r0, [r6]
      orr r0,r0, #PORT4
      str r0, [r6]	   
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; port H direction  (signaux DB7-4, E et R/W du LCD)
      ldr r6, = GPIO_PORTH_BASE + GPIODIR ;  Pins du port H en sortie
      ldr r0, = (DB7 + DB6 + DB5 + DB4 + E + RW)
      str r0, [r6]
; port H intensit(DB7-4, E et R/W)	
;		ldr r6, = GPIO_PORTH_BASE + GPIODR2R	;; Choix de l'intensit de sortie (2mA)
;      ldr r0, = (DB7 + DB6 + DB5 + DB4 + E + RW)
;      str r0, [r6]
; port H enable (DB7-4, E et R/W)
      ldr r6, = GPIO_PORTH_BASE + GPIODEN ;  Pins du port H enable
      ldr r0, = PORT7 + PORT6 + PORT5 + PORT4 + PORT3 + PORT2
      str r0, [r6]
;
; on place touts les signaux a 0 en particulier RW et E
;
      ldr r6, = GPIO_PORTH_BASE + GPIODATA + ((DB7 + DB6 + DB5 + DB4 + E + RW) << 2)
      mov r3, #0
      str r3, [r6]
      pop {r0,r3,r6,pc}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; RS <= 0 pour selectionner le registre d'instruction du lcd
;
      export   RSir
RSir  push {r3,r6,lr}
      ldr r6, = GPIO_PORTC_BASE + GPIODATA + (RS << 2)
      mov r3, #0
      str r3, [r6]
      pop {r3,r6,pc}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; RS <= 1 pour selectionner le registre de donnes du lcd
;
      export   RSdr
RSdr  push{r3,r6,lr}
      ldr r6, = GPIO_PORTC_BASE + GPIODATA + (RS << 2)
      mov r3, #RS
      str r3, [r6]
      pop {r3,r6,pc}

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ecriture des 4b de PF de r2 vers le registre IR ou DR du LCD.
; le signal RS ayant ete pralablement positionn pour choisr IR ou DR
;
      
Write4bLCD
      push {r3,r6,lr}   ; sauvergarde du lr pour prevenir les appels imbriqus
      ; R/W <= 0 
      ; E   <= 0 dure du cycle Tc = > 1000ns
      ;
      ldr r6, = GPIO_PORTH_BASE + GPIODATA + ((RW + E) << 2)
      mov r3, #0
      str r3, [r6]
      nop   ; attendre Tsp1 = >60ns avant de positionner E a 1
      ;
      ; E <= 1 doit rester a 1 Tpw = >450ns
      ;
      ldr r6, = GPIO_PORTH_BASE + GPIODATA + (E << 2)
      mov r3, #E
      str r3, [r6]
      ;
      ; on positionne au plutot (Td= <360ns) les 
      ; 4b de PF de r2 sur les signaux de data
      ;
      ldr r6, = GPIO_PORTH_BASE + GPIODATA + ((DB7 + DB6 + DB5 + DB4) << 2)
      str r2,[r6]
      nop
      nop   ; pour atteindre Tpw = >450ns  
      ;
      ; E <= 0 
      ;
      ldr r6, = GPIO_PORTH_BASE + GPIODATA + (E << 2)
      mov r3, #0
      str r3, [r6]
      nop
      nop
      nop   ; pour attendre Tc = >1000ns (10000ns - Tpw = >550ns)
      nop   
      pop {r3,r6,pc} ; restaure le lr
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ecriture de r1 vers le registre IR ou DR du LCD.
; le signal RS doit avoir ete pralablement positionn pour choisr IR ou DR
;
      export   WriteLCD
WriteLCD
      push  {r1,r2,lr}         ; imbrication d'appel
      mov   r2, r1        ; on place dans le PF de r2 les 4b de PF de r1
      bl    Write4bLCD

      mov   r2, r1, LSL#4 ; on place dans le PF de r2 les 4b de pf de r1
      bl    Write4bLCD

      mov   r1, #D2ms
      bl    wait
      pop   {r1,r2,pc}          ; retour

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Sequence d'Initialisation du LCD
;
      export init_LCD
init_LCD
      push  {r1,r2,lr}
      ldr   r1, = D1s	; attendre >4.1ms
      bl    wait
      bl    RSir        ; on selectionne le registre d'instruction du lcd 
      mov   r2, #0x30   ; 1ier
      bl    Write4bLCD
      mov   r1, #D5ms	; attendre >4.1ms
      bl    wait
      bl    Write4bLCD  ; 2ieme
      mov   r1, #D150us ; attendre >100Uus
      bl    wait
      bl    Write4bLCD  ; 3ieme
      mov   r1, #D150us ;  attendre >100us
      bl    wait
      mov   r2, #0x20   ;
      bl    Write4bLCD
      mov   r1, #D150us ;  attendre >100us
      bl    wait
      mov   r1,#0x28    ; 2 lignes + matrice de 8x5 points
      bl    WriteLCD
      mov   r1, #D50us  ;  attendre >38us
      bl    wait
      mov   r1,#0x0f    ; Display ON + Cursor ON + Blinking ON
      bl    WriteLCD
      mov   r1, #D50us  ;  attendre >38us
      bl    wait
      ldr   r1, = 0x01  ; clear display 
      bl    WriteLCD
      mov   r1, #D5ms   ;  attendre >1.52ms
      bl    wait
      pop   {r1,r2,pc}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; putsLCD
; r0 = @ debut de chaines de caracteres termin par 0 pour la fin de chaine
;
         export   puts_LCD
puts_LCD
         push  {r1,lr}        ; pour l'imbrication d'appel

         BL RSdr           ; on oublie pas de selectionner le reg de donnes

TantQue  ldrb  r1,[r0],#1  ; r1 <= le caractere courant puis +1 sur r0
         cmp   r1,#0       ; r1 = la fin de chaine ?
         beq   fin_putsLCD
         bl    WriteLCD    ; affiche le caractere courant
         b     TantQue
fin_putsLCD
         pop {r1,pc}    ; retour
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; curs2
; deplace le curseur au debut de la 2ieme ligne
;
         export curs2_LCD
curs2_LCD
         push  {r1,lr}
         bl    RSir              ; selectionne le registre d'instruction du LCD
         ldr   r1, =(0x80+0x40)  ; pour placer le curseur au debut de la 2ieme ligne @0x40
         bl    WriteLCD
         mov   r1, #D2ms        ; attendre >38us
         bl    wait
         pop   {r1,pc}
         
         export curs1_LCD
curs1_LCD
         push  {r1,lr}
         bl    RSir              ; selectionne le registre d'instruction du LCD
         ldr   r1, =(0x80+0x00)  ; pour placer le curseur au debut de la 2ieme ligne @0x40
         bl    WriteLCD
         mov   r1, #D2ms        ; attendre >38us
         bl    wait
         pop   {r1,pc}         
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      export cursoff_LCD
cursoff_LCD
         push  {r1,lr}
         bl    RSir              ; selectionne le registre d'instruction du LCD
         ldr   r1, =(0x8 + 0x04)  ; Ecran ON + curseur OFF + Blink off
         bl    WriteLCD
         mov   r1, #D2ms        ; attendre >38us
         bl    wait 
         pop   {r1,pc}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; hex2ascii
; r0 contient la veleur 32bits hexa a convertir en ascii
; r1 = @ du caractere des unites :
;  0xFFFFFFFF
;           ^  ici
;
      export   hex2ascii
hex2ascii
;         push  {lr}
         push  {r0-r3}
         mov   r2,#0x7              ; indice dans la chaine dist
la1      bic   r3,r0,#0xfffffff0    ; r3 <= r0 ET /shift(r5) on ne garde que le demi octet de pf
         add   r3,r3,#'0'           ; on ajoute le code ascii '0'
         cmp   r3,#'9'              ; s'il est > '9'
         bls   pass1                ; sinon rien
         add   r3,r3,#7             ; on lui ajoute 7 pour 'A...F'
pass1    strb  r3,[r1],#-1          ; [r1] <= ascii contenu ds r3 et r1 <= r1 -1
         lsr   r0,r0,#4             ; on decale a droite 
         sub   r2,#1 
         cmp   r2,#0
         bne   la1
         pop   {r0-r3}
;         pop   {pc}
         bx    lr
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; store a 16bit binary number as an ASCII string of '0's and '1's
;  r0 = @ de la chaine de caracteres
;  r1 = la val hexa
;  r2 = la constante 10
;  r3 = sauv val inter
;  r4 = compteur [10..0]
; r5 = sauvg inter
      export   int2ascii

masq  equ   0x0000000f

int2ascii
         push  {lr}
         push  {r0-r5}

         mov   r4,#6          ; compteur chiffres        
       
         mov   r3,r1          ; copie de la val original
         mov  r2,#10

encore1
         udiv  r1,r1,r2       ; R1 <= r1 / 10 (on perd la decimal)
         mov   r5,r1          ; sauv pour le tour suivant
         mul   r1,r1,r2       ; R1 <= r1 * 10          
         sub   r1,r3,r1       ; on recupere l'unit         
         add   r1,r1,#'0'     ; ajoute le code ascii
         strb  r1,[r0],#-1
         sub   r4,r4,#1       ; chiffre suivant
         cmp   r4,#3
         bne   zozo
         mov   r1,#','
         strb  r1,[r0],#-1      
zozo     mov   r1,r5          ; pour le tour suivant
         mov   r3,r5
         cmp   r4,#0
         bne   encore1

         pop   {r0-r5}
         pop   {pc}

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
         align
         end