//****************************************************************************
//
// chronos_drive.c - Controle l'EvalBot via UART bas sur Remote control of
// the EVALBOT using an eZ430-Chronos.
//
//****************************************************************************
#include "inc/hw_types.h"
#include "inc/hw_memmap.h"
#include "driverlib/sysctl.h"
#include "driverlib/flash.h"
#include "driverlib/debug.h"
#include "driverlib/interrupt.h"
#include "driverlib/udma.h"
#include "drivers/display96x16x1.h"
#include "drivers/motor.h"
#include "drivers/io.h"
#include "drivers/sensors.h"
#include "drivers/dac.h"
#include "drivers/sound.h"
#include "drivers/wav.h"
#include "utils/uartstdio.h"
#include "utils/ustdlib.h"
#include "utils/scheduler.h"
#include "simplicitilib.h"
#include <string.h>
#include "driverlib/uart.h"
#include "I2Clib.h"
#include "driverlib/timer.h"

//*****************************************************************************
//
// Defines
//
//*****************************************************************************
#define CLEAR 1
#define HideCurs    "\033[?25l"
#define ClearScreen "\033[H\033[2J"
// This example code is in the public domain.
// 0xE0 = 112 dec sur 7 bits de PF
// 0XE2 = 113
// 0XE4 = 114

#define srf02_g 112
#define srf02_g 112
//*****************************************************************************
//
// Main application entry point.
//
//*****************************************************************************
int main (void)
{
   unsigned long int i,j;
	char mess[5];
	
   //
   // Set the system clock to run at 50MHz from the PLL
   //
   SysCtlClockSet(SYSCTL_SYSDIV_4 | SYSCTL_USE_PLL | SYSCTL_OSC_MAIN | SYSCTL_XTAL_16MHZ);

   //
   // Enable UART0.
   //
   SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOA);
   SysCtlPeripheralEnable(SYSCTL_PERIPH_UART0);
   GPIOPinTypeUART(GPIO_PORTA_BASE, GPIO_PIN_0 | GPIO_PIN_1);
   //
   // Initialize the UART standard I/O.
   //
   UARTStdioInit(0);
	UARTConfigSetExpClk( UART0_BASE, SysCtlClockGet(), 9600,
                        (UART_CONFIG_WLEN_8 | UART_CONFIG_STOP_ONE |
                        UART_CONFIG_PAR_NONE) );
   //                    
   // pour activer le convertisseur +5v  PBA6 = 1
   //
   GPIOPinTypeGPIOOutput( GPIO_PORTA_BASE, (GPIO_PIN_6) );
   GPIOPadConfigSet( GPIO_PORTA_BASE, GPIO_PIN_6, GPIO_STRENGTH_2MA, GPIO_PIN_TYPE_STD );
   GPIOPinWrite( GPIO_PORTA_BASE,(GPIO_PIN_6), 0x40);
   //
   // Print a nice welcoming banner on the serial output.
   //
	UARTprintf(ClearScreen);  // efface la console 
	UARTprintf(HideCurs);	  // efface le curseur
   UARTprintf("EVALBOT test I2C + SRF02\n");
   UARTprintf("------------------------\n");
   //
   // Initialize the LED display.
   //
   Display96x16x1Init(true);
   Display96x16x1Clear();
	Display96x16x1StringDrawCentered("TesT I2C + SRF02", 0, CLEAR);
   //
   // Initialize the board LEDs.
   //
	I2CInit(GPIO_PB2_I2C0SCL);
 	
   for (;;) {
      // lecture capteur de gauche
      mess[0] = 0x00; // sets register pointer to the command register (0x00)
      mess[1] = 0x51; // command sensor to measure in centimeters (use 0x51 for cm)  
      I2CWriteData(I2C0_MASTER_BASE, 112, mess, 2);
      for (i=0;i<800000;i++);
      I2CWriteData(I2C0_MASTER_BASE, 113, mess, 2);
      for (i=0;i<800000;i++);
   
      mess[0] = 0x02;
		I2CWriteData(I2C0_MASTER_BASE, 112, mess, 1);
   	i = I2CReadData(I2C0_MASTER_BASE, 112, mess, 2);
		if (i == 2 ) { 
			j = mess[0]<<8; j |= mess[1];
			UARTprintf("\33[4;0Hdg = %d cm\n", j);
      }
      // lecture capteur de droite
      mess[0] = 0x00; // sets register pointer to the command register (0x00)
      mess[1] = 0x51; // command sensor to measure in centimeters (use 0x51 for cm)  
      I2CWriteData(I2C0_MASTER_BASE, 112, mess, 2);
      for (i=0;i<800000;i++);
      I2CWriteData(I2C0_MASTER_BASE, 113, mess, 2);
      for (i=0;i<800000;i++);
   
      mess[0] = 0x02;

      for (i=0;i<800000;i++);
		I2CWriteData(I2C0_MASTER_BASE, 113, mess, 1);  		
		i = I2CReadData(I2C0_MASTER_BASE, 113, mess, 2);
		if (i == 2 ) { 
			j = mess[0]<<8; j |= mess[1];
			UARTprintf("dd = %d cm ", j);
      }
		for (i=0;i<800000;i++);
	}
}
