	;; RK 11/2012 - Evalbot (Cortex M3 de Texas Instrument)
	;; fait clignoter une seule LED connecte au port GPIOF
   	
		AREA    |PRG1|, CODE, READONLY
 
; This register controls the clock gating logic in normal Run mode
SYSCTL_PERIPH_GPIOF EQU		0x400FE108	; SYSCTL_RCGC2_R (p291 datasheet de lm3s9b92.pdf)

; The GPIODATA register is the data register
GPIO_PORTD_BASE		EQU		0x40007000	; GPIO Port D (APB) base: 0x4000.7000 (p416 datasheet de lm3s9B92.pdf)
GPIO_PORTE_BASE		EQU		0x40024000  ; GPIO Port E (APB) base: 0x4002.4000
GPIO_PORTF_BASE		EQU		0x40025000	; GPIO Port F (APB) base: 0x4002.5000 (p416 datasheet de lm3s9B92.pdf)
GPIO_PORTJ_BASE		EQU		0x4003D000  ; GPIO Port J (APB) base: 0x4003.B000

; configure the corresponding pin to be an output
; all GPIO pins are inputs by default
GPIO_O_DIR   		EQU 	0x00000400  ; GPIO Direction (p417 datasheet de lm3s9B92.pdf)

; The GPIODR2R register is the 2-mA drive control register
; By default, all GPIO pins have 2-mA drive.
GPIO_O_DR2R   		EQU 	0x00000500  ; GPIO 2-mA Drive Select (p428 datasheet de lm3s9B92.pdf)

; Digital enable register
; To use the pin as a digital input or output, the corresponding GPIODEN bit must be set.
GPIO_O_DEN   		EQU 	0x0000051C  ; GPIO Digital Enable (p437 datasheet de lm3s9B92.pdf)

GPIO_O_PUR			EQU		0x00000510   ; resistance


LED1				EQU		0x10		; led1 sur port 4
LED2				EQU		0x20		; led2 sur port 5
SW1					EQU		0x40		; SW1 sur port 6
SW2					EQU		0x80		; SW2 sur port 7
BUMP_G				EQU		0x01		; bumper gauche
BUMP_D				EQU		0x02		; bumper droit
PJ1					EQU		0x02		; Sortie
PJ3					EQU		0x04		; Entre

	  	ENTRY
		EXPORT __main
		
		; IMPORT  MOTEUR_INIT                                     ; initialise les moteurs (configure les pwms + GPIO)
        	
        ; IMPORT  MOTEUR_DROIT_ON                         ; activer le moteur droit
        ; IMPORT  MOTEUR_DROIT_OFF                        ; dactiver le moteur droit
        ; IMPORT  MOTEUR_DROIT_AVANT                      ; moteur droit tourne vers l'avant
        ; IMPORT  MOTEUR_DROIT_ARRIERE            ; moteur droit tourne vers l'arrire
        ; IMPORT  MOTEUR_DROIT_INVERSE            ; inverse le sens de rotation du moteur droit
        	
        ; IMPORT  MOTEUR_GAUCHE_ON                        ; activer le moteur gauche
        ; IMPORT  MOTEUR_GAUCHE_OFF                       ; dactiver le moteur gauche
        ; IMPORT  MOTEUR_GAUCHE_AVANT                     ; moteur gauche tourne vers l'avant
        ; IMPORT  MOTEUR_GAUCHE_ARRIERE           ; moteur gauche tourne vers l'arrire
        ; IMPORT  MOTEUR_GAUCHE_INVERSE           ; inverse le sens de rotation du moteur gauche
				
__main


		; ;; Enable the Port F peripheral clock by setting bit 5 (0x20 == 0b100000)		(p291 datasheet de lm3s9B96.pdf)
		; ;;														 (GPIO::FEDCBA)
		ldr r6, = SYSCTL_PERIPH_GPIOF  			;; RCGC2
        mov r0, #0x00000078  					;; Enable clock sur GPIO D et E o sont branchs les leds (0x30 == 0b1111000)
		; ;;														 									 (GPIO::JFEDCBA)
        str r0, [r6]
		
		; ;; "There must be a delay of 3 system clocks before any GPIO reg. access  (p413 datasheet de lm3s9B92.pdf)
		nop	   									;; tres tres important....
		nop	   
		nop	
		nop
		nop	;; pas necessaire en simu ou en debbug step by step...
	
		;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^CONFIGURATION LED

        ldr r6, = GPIO_PORTF_BASE+GPIO_O_DIR    ;; 2 Pin du portF en sorties 
        ldr r0, = LED1 + LED2
		
        str r0, [r6]
		
        ldr r6, = GPIO_PORTF_BASE+GPIO_O_DEN	;; Enable Digital Function 
        ldr r0, = LED1 + LED2	
        str r0, [r6]
 
		ldr r6, = GPIO_PORTF_BASE+GPIO_O_DR2R	;; Choix de l'intensit de sortie (2mA)
        ldr r0, = LED1 + LED2
        str r0, [r6]


		;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^CONFIGURATION Bouton

		ldr r6, = GPIO_PORTD_BASE+GPIO_O_DIR    ;; 2 Pin du portD en entres
        ldr r0, = 0x00
        str r0, [r6]
		
        ldr r6, = GPIO_PORTD_BASE+GPIO_O_DEN	;; Enable Digital Function 
        ldr r0, = SW1+SW2	
        str r0, [r6]
 
		ldr r6, = GPIO_PORTD_BASE+GPIO_O_PUR	;; Activation de la resistance pour les entres 
        ldr r0, = SW1+SW2
        str r0, [r6]


		;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^CONFIGURATION Port J
				
		ldr r7, = GPIO_PORTJ_BASE+GPIO_O_DIR    ;; 1 Pin du portF en sortie (broche : 00011000)
		ldr r1, = PJ1
		ldr r2 , [r7]
		add r1, r1, r2
		str r1, [r7]
				
		ldr r7,	= GPIO_PORTJ_BASE+GPIO_O_PUR	;;mettre  1 dans le pullup (GRPIO_I_PUR) port 0 et port 1 des bumper
		ldr	r1,	= PJ3
		str	r1,	[r7]
				
		ldr r7, = GPIO_PORTJ_BASE+GPIO_O_DEN	;; Enable Digital Function bumper
		ldr r1, = PJ3	
		str r1, [r7]
				
				

		ldr r6, = GPIO_PORTJ_BASE+GPIO_O_DIR    ;; 1 Pin du portF en sortie (broche : 00011000)
		ldr r0, = PJ1
		str r0, [r6]
				
		ldr r6, = GPIO_PORTJ_BASE+GPIO_O_DEN	;; Enable Digital Function 
		ldr r0, = PJ1
		str r0, [r6]
		 
		ldr r6, = GPIO_PORTJ_BASE+GPIO_O_DR2R	;; Choix de l'intensit de sortie (2mA)
		ldr r0, = PJ1	
		str r0, [r6]

		
		;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^CONFIGURATION Bumper
				
		ldr r6, = GPIO_PORTE_BASE+GPIO_O_DIR    ;; 2 Pin du portE en entres
		ldr r0, = 0x00
		str r0, [r6]
				
		ldr r6,	= GPIO_PORTE_BASE+GPIO_O_PUR	;;mettre  1 dans le pullup (GRPIO_I_PUR) port 0 et port 1 des bumper
		ldr	r0,	= BUMP_G+BUMP_D
		str	r0,	[r6]
				
		ldr r6, = GPIO_PORTE_BASE+GPIO_O_DEN	;; Enable Digital Function bumper
		ldr r0, = BUMP_G+BUMP_D
		str r0, [r6]

		;vvvvvvvvvvvvvvvvvvvvvvvFin configuration


        ldr r6,  = GPIO_PORTJ_BASE + (PJ1<<2)
		ldr r7,  = GPIO_PORTJ_BASE + (PJ3<<2)
		ldr r8,  = GPIO_PORTE_BASE + (BUMP_G<<2)	;;Bumper gauche
		ldr r9,  = GPIO_PORTE_BASE + (BUMP_D<<2)	;; bumper droit
		ldr	r10, = GPIO_PORTD_BASE + (SW1<<2)  ;; SW1
		ldr	r11, = GPIO_PORTD_BASE + (SW2<<2)  ;; SW2
		ldr r12, = GPIO_PORTF_BASE + ((LED1 + LED2)<<2)
		;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^Execution

		ldr r3, = LED1+LED2  					;; Allume portF broche 4 : 00010000		
loop	str r3,[r12]


		
		nop		
        END 